# -*- coding: utf-8 -*-
"""
Created on Fri Aug 21 16:33:05 2015

@author: jamezcua
"""
import numpy as np
import scipy as sp

def getHR(gridobs,nx,stdobs):
    if gridobs ==1:
        nx_obs = nx
    if gridobs ==2 or gridobs==3:
        nx_obs = np.int(nx/2)
    if gridobs ==4:
        nx_obs = np.int(nx/4)
    if gridobs ==5:
        nx_obs = 1
    
    # Create H
    if gridobs<4:
        H = np.eye(nx,nx)
        # get rid of unused parts of H 
        if gridobs==2:
            for i in range(nx):
                if i%2==0:
                    H[i,i]=0
        if gridobs==3:
            for i in range(nx):
                if i>=(nx/2) and i<nx:
                    H[i,i]=0
        H = H[~np.all(H == 0, axis=1)]
        
    if gridobs==4:
        H = np.zeros((nx_obs,nx))
        ind = range(3-1,np.int(nx),4)
        for i in range(np.int(nx_obs)):
            H[i,ind[i]] = 1.0
        del i
    
    if gridobs==5: # quite ad hoc
        H = np.zeros((1,nx))
        H[0,np.int(nx/2)] = 1.0
    
    # location of obs    
    loc_obs = range(1,nx+1,1)
    loc_obs = np.dot(H,loc_obs)
    loc_obs = loc_obs[loc_obs>0]
    loc_obs = loc_obs-1
    
    # Create R
    if gridobs<6:
        R = np.eye(nx_obs)
        for i in range(nx_obs):
            R[i,i]= stdobs**2
            
    Rsq = sp.linalg.sqrtm(R);   
    invR = sp.linalg.pinv(R)

    return nx_obs, loc_obs, H, R, Rsq, invR     
    



def genobs(dt,ut,Nsteps,Nx_obs,H,period_obs,Rsq):
    obsnum = (Nsteps-1)/period_obs
    y = np.empty((Nsteps,Nx_obs))
    y.fill(np.nan)
    for i in range(int(obsnum)):
        y[(i+1)*period_obs,:]= np.dot(H,ut[(i+1)*period_obs,:]) \
        + np.dot(Rsq,(np.random.randn(Nx_obs)).T)
    del i              
    y2 = y[np.arange(period_obs,period_obs*(int(obsnum)+1),period_obs),:]
    tobs = np.arange(period_obs,Nsteps+1,period_obs) *dt
    return tobs, y2






